from typing import Any, Dict, Type, TypeVar, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from ..types import UNSET, Unset
from typing import Union
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from ..models.team_season_standings import TeamSeasonStandings


T = TypeVar("T", bound="SeasonStandings")


@_attrs_define
class SeasonStandings:
    """
    Attributes:
        standings (List['TeamSeasonStandings']):
        wild_card_indicator (Union[Unset, bool]):
    """

    standings: List["TeamSeasonStandings"]
    wild_card_indicator: Union[Unset, bool] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        standings = []
        for standings_item_data in self.standings:
            standings_item = standings_item_data.to_dict()

            standings.append(standings_item)

        wild_card_indicator = self.wild_card_indicator

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "standings": standings,
            }
        )
        if wild_card_indicator is not UNSET:
            field_dict["wildCardIndicator"] = wild_card_indicator

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.team_season_standings import TeamSeasonStandings

        d = src_dict.copy()
        standings = []
        _standings = d.pop("standings")
        for standings_item_data in _standings:
            standings_item = TeamSeasonStandings.from_dict(standings_item_data)

            standings.append(standings_item)

        wild_card_indicator = d.pop("wildCardIndicator", UNSET)

        season_standings = cls(
            standings=standings,
            wild_card_indicator=wild_card_indicator,
        )

        season_standings.additional_properties = d
        return season_standings

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
